//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2001
//  Example 10.22 on page 199
//  Testing BinaryTree traversal algorithms

import java.util.*;
import schaums.dswj.BinaryTree;

public class Ex1022
{ static public void main(String[] args)
  { BinaryTree e = new BinaryTree("E");
    BinaryTree g = new BinaryTree("G");
    BinaryTree h = new BinaryTree("H");
    BinaryTree i = new BinaryTree("I");
    BinaryTree d = new BinaryTree("D",null,g);
    BinaryTree f = new BinaryTree("F",h,i);
    BinaryTree b = new BinaryTree("B",d,e);
    BinaryTree c = new BinaryTree("C",f,null);
    BinaryTree tree = new BinaryTree("A",b,c);
    System.out.println("tree = " + tree);
    BinaryTree.Iterator it;
    System.out.print("PreOrder Traversal:   ");
    for (it = tree.new PreOrder(); it.hasNext(); )
      System.out.print(it.next() + " ");
    System.out.print("\nInOrder Traversal:    ");
    for (it = tree.new InOrder(); it.hasNext(); )
      System.out.print(it.next() + " ");
    System.out.print("\nPostOrder Traversal:  ");
    for (it = tree.new PostOrder(); it.hasNext(); )
      System.out.print(it.next() + " ");
    System.out.print("\nLevelOrder Traversal: ");
    for (it = tree.new LevelOrder(); it.hasNext(); )
      System.out.print(it.next() + " ");
    System.out.println();
  }
}
