//  Data Structures with Java by John R. Hubbard
//  Copyright McGraw-Hill, 2000
//  Problem 10.30 on page 
//  The number of leaves in a binary tree

import java.util.*;
import schaums.dswj.BinaryTree;

public class Testing
{ static public void main(String[] args)
  { BinaryTree tree = sample();
    BinaryTree.PreOrder it = tree.new PreOrder(tree);
System.out.println("++++++++++++++++++++++++++++++++++++++++++");
    for ( ; it.hasNext(); it.next())
      ;
System.out.println("++++++++++++++++++++++++++++++++++++++++++");
//    System.out.println("numLeaves(tree) = " + numLeaves(tree));
//    print(tree);
  }

  public static int numLeaves(BinaryTree tree)
  { int count=0;
    BinaryTree.PreOrder it = tree.new PreOrder(tree);
System.out.println("============================================");
    for ( ; it.hasNext(); it.next())
      ;
//      System.out.println("====> " + it.cursor);
//      if (it.isLeaf()) ++ count;
    return count;
  }

  public static BinaryTree sample()
  { BinaryTree e = new BinaryTree("E");
    BinaryTree g = new BinaryTree("G");
    BinaryTree h = new BinaryTree("H");
    BinaryTree i = new BinaryTree("I");
    BinaryTree d = new BinaryTree("D",null,g);
    BinaryTree f = new BinaryTree("F",h,i);
    BinaryTree b = new BinaryTree("B",d,e);
    BinaryTree c = new BinaryTree("C",f,null);
    BinaryTree tree = new BinaryTree("A",b,c);
    return tree;
  }

  public static void print(BinaryTree tree)
  { System.out.println("tree = " + tree);
    BinaryTree.Iterator it;
    System.out.print("PreOrder Traversal:   ");
    for (it = tree.new PreOrder(tree); it.hasNext(); )
      System.out.print(it.next() + " ");
    System.out.print("\nInOrder Traversal:    ");
    for (it = tree.new InOrder(); it.hasNext(); )
      System.out.print(it.next() + " ");
    System.out.print("\nPostOrder Traversal:  ");
    for (it = tree.new PostOrder(); it.hasNext(); )
      System.out.print(it.next() + " ");
    System.out.print("\nLevelOrder Traversal: ");
    for (it = tree.new LevelOrder(); it.hasNext(); )
      System.out.print(it.next() + " ");
    System.out.println();
  }
}


/*
cursor=[A, B, D, G, E, C, F, H, I]
cursor=[B, D, G, E]
cursor=[D, G]
cursor=[G]
cursor=[E]
cursor=[C, F, H, I]
cursor=[F, H, I]
cursor=[H]
cursor=[I]
++++++++++++++++++++++++++++++++++++++++++
>> cursor=[A, B, D, G, E, C, F, H, I]
>> cursor=[A, B, D, G, E, C, F, H, I]
>> cursor=[B, D, G, E]
>> cursor=[A, B, D, G, E, C, F, H, I]
>> cursor=[B, D, G, E]
>> cursor=[D, G]
>> cursor=[A, B, D, G, E, C, F, H, I]
>> cursor=[B, D, G, E]
>> cursor=[D, G]
>> cursor=[G]
>> cursor=[A, B, D, G, E, C, F, H, I]
>> cursor=[B, D, G, E]
>> cursor=[E]
>> cursor=[A, B, D, G, E, C, F, H, I]
>> cursor=[C, F, H, I]
>> cursor=[A, B, D, G, E, C, F, H, I]
>> cursor=[C, F, H, I]
>> cursor=[F, H, I]
>> cursor=[A, B, D, G, E, C, F, H, I]
>> cursor=[C, F, H, I]
>> cursor=[F, H, I]
>> cursor=[H]
>> cursor=[A, B, D, G, E, C, F, H, I]
>> cursor=[C, F, H, I]
>> cursor=[F, H, I]
>> cursor=[I]
++++++++++++++++++++++++++++++++++++++++++
*/
